"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_extra_1 = __importDefault(require("fs-extra"));
const ansi_colors_1 = __importDefault(require("ansi-colors"));
const setup_dom_1 = __importDefault(require("./setup-dom"));
const CWD = process.cwd();
async function default_1() {
    if (!(await fs_extra_1.default.pathExists(`${CWD}/memserver`))) {
        throw new Error(ansi_colors_1.default.red("/memserver folder doesn't exist for this directory!"));
    }
    else if (!(await fs_extra_1.default.pathExists(`${CWD}/memserver/models`))) {
        throw new Error(ansi_colors_1.default.red("/memserver/models folder doesn't exist for this directory!"));
    }
    else if (!(await checkFile(`${CWD}/memserver/routes`))) {
        throw new Error(ansi_colors_1.default.red("/memserver/routes.ts doesn't exist for this directory!"));
    }
    else if (!(await checkFile(`${CWD}/memserver/initializer`))) {
        throw new Error(ansi_colors_1.default.red("/memserver/initializer.ts doesn't exist for this directory!"));
    }
    await setup_dom_1.default();
    window.Memserver = (await Promise.resolve().then(() => __importStar(require("./server")))).default;
    const [initializerModule, routesModule] = await Promise.all([
        Promise.resolve().then(() => __importStar(require(`${CWD}/memserver/initializer`))),
        Promise.resolve().then(() => __importStar(require(`${CWD}/memserver/routes`)))
    ]);
    window.MemServer = new window.Memserver({
        globalizeModels: true,
        initializer: initializerModule.default,
        routes: routesModule.default
    });
    return window.MemServer;
}
exports.default = default_1;
async function checkFile(filePath) {
    return await fs_extra_1.default.pathExists(`${filePath}.ts`) || await fs_extra_1.default.pathExists(`${filePath}.js`);
}
